version: '3'

volumes:
  db:

networks:
  backend:
    driver: bridge
    name: backend
  web-proxy:
    driver: bridge
    name: web-proxy
  

services:
  nginx-proxy:
    image: jwilder/nginx-proxy
    networks:
      - web-proxy
    ports:
      - "80:80"
    depends_on:
      - frontend
      - backend
    volumes:
      - /var/run/docker.sock:/tmp/docker.sock:ro
    environment:
      DEFAULT_HOST: web2.localhost
    labels:
      app: react-spring
    healthcheck:
      test: ["CMD", "curl", "--fail http://nginx-proxy:80 || exit 1" ]
      interval: 30s
      timeout: 3s
      retries: 3
      start_period: 30s

  backend:
    build:
      context: backend
      dockerfile: Dockerfile
    image: registry.gitlab.com/taro12/2-deusops_task/backend
    environment:
      SPRING_DATASOURCE_URL: jdbc:mysql://db:3306/fullstack
      SPRING_DATASOURCE_USERNAME: user
      SPRING_DATASOURCE_PASSWORD: pass
      VIRTUAL_HOST: web2.localhost
      VIRTUAL_PORT: 8080
      VIRTUAL_PATH: /api
      VIRTUAL_DEST: /
    restart: always
    deploy:
      mode: replicated
      replicas: 3
    networks:
      - backend
    expose:
      - 8080
    labels:
      app: react-spring
    depends_on:
      - db
    healthcheck:
      test: [ "CMD", "curl", "--fail http://backend:8080 || exit 1" ]
      interval: 30s
      timeout: 3s
      retries: 3
      start_period: 30s

  frontend:
    build:
      context: frontend
      dockerfile: Dockerfile
    image: registry.gitlab.com/taro12/2-deusops_task/frontend
    deploy:
      mode: replicated
      replicas: 3
    expose:
      - 80
    labels:
      app: react-spring
    environment:
      VIRTUAL_HOST: web2.localhost
      VIRTUAL_PATH: /
      USE_IP_HASH: 1
    depends_on:
      - backend
    healthcheck:
      test: [ "CMD", "curl", "--fail http://frontend:80 || exit 1" ]
      interval: 30s
      timeout: 3s
      retries: 3
      start_period: 30s
    networks:
      - web-proxy
      - backend

  db:
    image: 'bitnami/mariadb:latest'
    container_name: db
    tty: true
    labels:
      app: react-spring
    expose:
      - 3306
    volumes:
      - db:/var/lib/mysql
    environment:
      - MARIADB_REPLICATION_MODE=master
      - MARIADB_DATABASE=fullstack
      - MARIADB_USER=user
      - MARIADB_PASSWORD=pass
      - MARIADB_ROOT_PASSWORD=password
      - MARIADB_REPLICATION_USER=replicationuser
      - MARIADB_REPLICATION_PASSWORD=replicationpassword
    healthcheck:
      test: "mysqladmin -uroot -ppassword ping -h db || exit 1"
      interval: 2s
      timeout: 20s
      retries: 10
    networks:
      - backend
  
  checker: 
    image: 'registry.gitlab.com/taro12/2-deusops_task/checker'
    build:
      context: checker
      dockerfile: Dockerfile
    depends_on:
      - db
      - backend
      - frontend
      - nginx-proxy
    volumes:
    - type: bind
      source: /var/run/docker.sock
      target: /var/run/docker.sock
      read_only: true
    